---
title: HTMLInputElement.webkitdirectory
slug: Web/API/HTMLInputElement/webkitdirectory
tags:
  - API
  - File System API
  - File and Directory Entries API
  - Files
  - HTML DOM
  - HTMLInputElement
  - Non-standard
  - Property
  - Reference
  - Web
  - webkitdirectory
---
<p>{{APIRef("HTML DOM")}}{{non-standard_header}}</p>

<p><span class="seoSummary">The <code><strong>HTMLInputElement.webkitdirectory</strong></code> is a property that reflects the {{htmlattrxref("webkitdirectory", "input")}} HTML attribute and indicates that the {{HTMLElement("input")}} element should let the user select directories instead of files. When a directory is selected, the directory and its entire hierarchy of contents are included in the set of selected items. The selected file system entries can be obtained using the {{domxref("HTMLInputElement.webkitEntries", "webkitEntries")}} property.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> <em>HTMLInputElement</em>.webkitdirectory = <em>boolValue</em></pre>

<h3 id="Value">Value</h3>

<p>A Boolean; <code>true</code> if the {{HTMLElement("input")}} element should allow picking only directories or <code>false</code> if only files should be selectable.</p>

<h2 id="Understanding_the_results">Understanding the results</h2>

<p>After the user makes a selection, each {{domxref("File")}} object in <code>files</code> has its {{domxref("File.webkitRelativePath")}} property set to the relative path within the selected directory at which the file is located. For example, consider this file system:</p>

<ul>
 <li>PhotoAlbums
  <ul>
   <li>Birthdays
    <ul>
     <li>Jamie's 1st birthday
      <ul>
       <li>PIC1000.jpg</li>
       <li>PIC1004.jpg</li>
       <li>PIC1044.jpg</li>
      </ul>
     </li>
     <li>Don's 40th birthday
      <ul>
       <li>PIC2343.jpg</li>
       <li>PIC2344.jpg</li>
       <li>PIC2355.jpg</li>
       <li>PIC2356.jpg</li>
      </ul>
     </li>
    </ul>
   </li>
   <li>Vacations
    <ul>
     <li>Mars
      <ul>
       <li>PIC5533.jpg</li>
       <li>PIC5534.jpg</li>
       <li>PIC5556.jpg</li>
       <li>PIC5684.jpg</li>
       <li>PIC5712.jpg</li>
      </ul>
     </li>
    </ul>
   </li>
  </ul>
 </li>
</ul>

<p>If the user chooses <code>PhotoAlbums</code>, then the list reported by files will contain {{domxref("File")}} objects for every file listed above—but not the directories. The entry for <code>PIC2343.jpg</code> will have a <code>webkitRelativePath</code> of <code>PhotoAlbums/Birthdays/Don's 40th birthday/PIC2343.jpg</code>. This makes it possible to know the hierarchy even though the {{domxref("FileList")}} is flat.</p>

<div class="note">
<p><strong>Note:</strong> The behavior of <code>webkitRelativePath</code> is different in <em>Chromium &lt; 72</em>. See <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=124187">this bug</a> for further details.</p>
</div>

<h2 id="Example">Example</h2>

<p>In this example, a directory picker is presented which lets the user choose one or more directories. When the {{event("change")}} event occurs, a list of all files contained within the selected directory hierarchies is generated and displayed.</p>

<h3 id="HTML_content">HTML content</h3>

<pre class="brush: html">&lt;input type="file" id="filepicker" name="fileList" webkitdirectory multiple /&gt;
&lt;ul id="listing"&gt;&lt;/ul&gt;</pre>

<h3 id="JavaScript_content">JavaScript content</h3>

<pre class="brush: js">document.getElementById("filepicker").addEventListener("change", function(event) {
  let output = document.getElementById("listing");
  let files = event.target.files;

  for (let i=0; i&lt;files.length; i++) {
    let item = document.createElement("li");
    item.innerHTML = files[i].webkitRelativePath;
    output.appendChild(item);
  };
}, false);
</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Example') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-htmlinputelement-webkitdirectory', 'webkitdirectory') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLInputElement.webkitdirectory")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li>{{domxref("HTMLInputElement.webkitEntries")}}</li>
 <li>{{domxref("File.webkitRelativePath")}}</li>
</ul>
